# coding: utf-8
"""Waylay Function Registry models.

This code was generated from the OpenAPI documentation of 'Waylay Function Registry'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import List

from pydantic import (
    ConfigDict,
    Field,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.function_type import FunctionType
from ..models.job_state_result import JobStateResult
from ..models.job_type_schema import JobTypeSchema
from ..models.timestamp_spec import TimestampSpec


class JobQuery(WaylayBaseModel):
    """JobQuery."""

    limit: (
        Annotated[float, Field(strict=True, ge=0)]
        | Annotated[int, Field(strict=True, ge=0)]
        | None
    ) = Field(
        default=None,
        description="The maximum number of items to be return from this query. Has a deployment-defined default and maximum value.",
    )
    type: List[JobTypeSchema] | None = Field(
        default=None, description="Filter on job type"
    )
    state: List[JobStateResult] | None = Field(
        default=None, description="Filter on job state"
    )
    function_type: List[FunctionType] | None = Field(
        default=None, description="Filter on function type", alias="functionType"
    )
    created_before: TimestampSpec | None = Field(default=None, alias="createdBefore")
    created_after: TimestampSpec | None = Field(default=None, alias="createdAfter")

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
